; Technology File NCSU FreePDK 45nm

;********************************
; CONTROLS
;********************************

controls(
  techParams(
    ;(  parameter        value    )
    ;(  ---------        -----    )
     (  technologyName   "NG45nm"  )
  ) ;techParams
) ;controls



;********************************
; LAYER DEFINITION
;********************************
layerDefinitions(

 techLayers(
 ;( LayerName                 Layer#     Abbreviation )
 ;( ---------                 ------     ------------ )
  ( nwell                     11          nwell )
  ( pwell                     12          pwell )
  ( nimplant                  13          nimplant )
  ( pimplant                  14          pimplant )
  ( active                    15         active )
  ( poly                      16         poly )
  ( contact                   17         contact )
  ( metal1                    21         metal1 )
  ( via1                      22         via1 )
  ( metal2                    23         metal2 )
  ( via2                      24         via2 )
  ( metal3                    25         metal3 )
  ( via3                      26         via3 )
  ( metal4                    27         metal4 )
  ( via4                      28         via4 )
  ( metal5                    29         metal5 )
  ( via5                      30         via5 )
  ( metal6                    31         metal6 )
  ( via6                      32         via6 )
  ( metal7                    33         metal7 )
  ( via7                      34         via7 )
  ( metal8                    35         metal8 )
  ( via8                      36         via8 )
  ( metal9                    37         metal9 )
  ( via9                      38         via9 )
  ( metal10                   39         metal10 )
 ;System-reserved layers:
  (  Unrouted       200           Unroute         )
  (  Row            201           Row             )
  (  Group          202           Group           )
  (  Cannotoccupy   203           noOcupy         )
  (  Canplace       204           Canplac         )
  (  hardFence      205           hardFnc         )
  (  softFence      206           softFnc         )
  (  y0             207           y0              )
  (  y1             208           y1              )
  (  y2             209           y2              )
  (  y3             210           y3              )
  (  y4             211           y4              )
  (  y5             212           y5              )
  (  y6             213           y6              )
  (  y7             214           y7              )
  (  y8             215           y8              )
  (  y9             216           y9              )
  (  designFlow     217           dsnFlow         )
  (  stretch        218           stretch         )
  (  edgeLayer      219           edgeLyr         )
  (  changedLayer   220           chngLyr         )
  (  unset          221           unset           )
  (  unknown        222           unknown         )
  (  spike          223           spike           )
  (  hiz            224           hiz             )
  (  resist         225           resist          )
  (  drive          226           drive           )
  (  supply         227           supply          )
  (  wire           228           wire            )
  (  pin            229           pin             )
  (  text           230           text            )
  (  device         231           device          )
  (  border         232           border          )
  (  snap           233           snap            )
  (  align          234           align           )
  (  prBoundary     235           prBndry         )
  (  instance       236           instnce         )
  (  annotate       237           anotate         )
  (  marker         238           marker          )
  (  select         239           select          )
  (  substrate      240           substra         )
  (  grid           251           grid            )
  (  axis           252           axis            )
  (  hilite         253           hilite          )
  (  background     254           bkground        )
 ) ;techLayers

  techPurposes(
    ;(  PurposeName   PurposeNumber   [Abbreviation]  )
    ;(  -----------   -------------   --------------  )
    ;User-defined layers:
     (  dummy         51              dummy           )
    ;(  blockage      2               blockage        )
     (  metal1        21              metal1          )
     (  metal2        23              metal2          )
     (  metal3        25              metal3          )
     (  metal4        27              metal4          )
     (  metal5        29              metal5          )
     (  metal6        31              metal6          )
     (  metal7        33              metal7          )
     (  metal8        35              metal8          )
     (  metal9        37              metal9          )
     (  metal10       39              metal10         )
  ) ;techPurposes


 techLayerPurposePriorities(
 ;layers are ordered from lowest to highest priority
 ;( LayerName                 Purpose    )
 ;( ---------                 -------    )
  ( nwell                     drawing )
  ( nwell                     net )
  ( nwell                     boundary )
  ( nwell                     label )
  ( pwell                     drawing )
  ( pwell                     net )
  ( pwell                     boundary )
  ( pwell                     label )
  ( nimplant                  drawing )
  ( nimplant                  boundary )
  ( nimplant                  label )
  ( pimplant                  drawing )
  ( pimplant                  boundary )
  ( pimplant                  label )
  ( active                    drawing )
  ( active                    net )
  ( active                    boundary )
  ( active                    dummy )
  ( active                    label )
  ( poly                      drawing )
  ( poly                      pin )
  ( poly                      net )
  ( poly                      boundary )
  ( poly                      dummy )
  ( poly                      label )
  ( contact                   drawing )
  ( contact                   net )
  ( contact                   boundary )
  ( contact                   dummy )
  ( contact                   label )
  ( metal1                    drawing )
  ( metal1                    pin )
  ( metal1                    net )
  ( metal1                    boundary )
  ( metal1                    dummy )
  ( metal1                    blockage )
  ( metal1                    label )
  ( via1                      drawing )
  ( via1                      net )
  ( via1                      boundary )
  ( via1                      dummy )
  ( via1                      label )
  ( metal2                    drawing )
  ( metal2                    pin )
  ( metal2                    net )
  ( metal2                    boundary )
  ( metal2                    dummy )
  ( metal2                    blockage )
  ( metal2                    label )
  ( via2                      drawing )
  ( via2                      net )
  ( via2                      boundary )
  ( via2                      dummy )
  ( via2                      label )
  ( metal3                    drawing )
  ( metal3                    pin )
  ( metal3                    net )
  ( metal3                    boundary )
  ( metal3                    dummy )
  ( metal3                    blockage )
  ( metal3                    label )
  ( via3                      drawing )
  ( via3                      net )
  ( via3                      boundary )
  ( via3                      dummy )
  ( via3                      label )
  ( metal4                    drawing )
  ( metal4                    pin )
  ( metal4                    net )
  ( metal4                    boundary )
  ( metal4                    dummy )
  ( metal4                    blockage )
  ( metal4                    label )
  ( via4                      drawing )
  ( via4                      net )
  ( via4                      boundary )
  ( via4                      dummy )
  ( via4                      label )
  ( metal5                    drawing )
  ( metal5                    pin )
  ( metal5                    net )
  ( metal5                    boundary )
  ( metal5                    dummy )
  ( metal5                    blockage )
  ( metal5                    label )
  ( via5                      drawing )
  ( via5                      net )
  ( via5                      boundary )
  ( via5                      dummy )
  ( via5                      label )
  ( metal6                    drawing )
  ( metal6                    pin )
  ( metal6                    net )
  ( metal6                    boundary )
  ( metal6                    dummy )
  ( metal6                    blockage )
  ( metal6                    label )
  ( via6                      drawing )
  ( via6                      net )
  ( via6                      boundary )
  ( via6                      dummy )
  ( via6                      label )
  ( metal7                    drawing )
  ( metal7                    pin )
  ( metal7                    net )
  ( metal7                    boundary )
  ( metal7                    dummy )
  ( metal7                    blockage )
  ( metal7                    label )
  ( via7                      drawing )
  ( via7                      net )
  ( via7                      boundary )
  ( via7                      dummy )
  ( via7                      label )
  ( metal8                    drawing )
  ( metal8                    pin )
  ( metal8                    net )
  ( metal8                    boundary )
  ( metal8                    dummy )
  ( metal8                    blockage )
  ( metal8                    label )
  ( via8                      drawing )
  ( via8                      net )
  ( via8                      boundary )
  ( via8                      dummy )
  ( via8                      label )
  ( metal9                    drawing )
  ( metal9                    pin )
  ( metal9                    net )
  ( metal9                    boundary )
  ( metal9                    dummy )
  ( metal9                    blockage )
  ( metal9                    label )
  ( via9                      drawing )
  ( via9                      net )
  ( via9                      boundary )
  ( via9                      dummy )
  ( via9                      label )
  ( metal10                   drawing )
  ( metal10                   pin )
  ( metal10                   net )
  ( metal10                   boundary )
  ( metal10                   dummy )
  ( metal10                   blockage )
  ( metal10                   label )
  (  pin            label        )
  (  pin            drawing      )
  (  pin            annotate     )
  (  text           drawing      )
  (  text           drawing1     )
  (  text           drawing2     )
  (  prBoundary     drawing      )
  (  prBoundary     boundary     )
  (  prBoundary     label        )
  (  hilite         drawing      )
  (  hilite         drawing1     )
  (  hilite         drawing2     )
  (  hilite         drawing3     )
  (  hilite         drawing4     )
  (  hilite         drawing5     )
  (  hilite         drawing6     )
  (  hilite         drawing7     )
  (  hilite         drawing8     )
  (  hilite         drawing9     )
  (  background     drawing      )
 ) ;techLayerPurposePriorities

  techDisplays(
    ;(  LayerName    Purpose      Packet          Vis Sel Con2ChgLy DrgEnbl Valid  )
    ;(  ---------    -------      ------          --- --- --------- ------- -----  )
    ;User-defined layers:
     (  nwell        drawing      nwell            t   t      t        t      t    )
     (  nwell        net          nwell           nil nil     t        t     nil   )
     (  nwell        boundary     nwell           nil nil     t        t     nil   )
     (  nwell        label        nwell            t   t      t        t      t    )
     (  pwell        drawing      pwell            t   t      t        t      t    )
     (  pwell        net          pwell           nil nil     t        t     nil   )
     (  pwell        boundary     pwell           nil nil     t        t     nil   )
     (  pwell        label        pwell            t   t      t        t      t    )
     (  nimplant     drawing      nimplant         t   t      t        t      t    )
     (  nimplant     boundary     nimplant        nil nil     t        t     nil   )
     (  nimplant     label        nimplant         t   t      t        t      t    )
     (  pimplant     drawing      pimplant         t   t      t        t      t    )
     (  pimplant     boundary     pimplant        nil nil     t        t     nil   )
     (  pimplant     label        pimplant         t   t      t        t      t    )
     (  active       drawing      active           t   t      t        t      t    )
     (  active       net          active          nil nil     t        t     nil   )
     (  active       boundary     active          nil nil     t        t     nil   )
     (  active       dummy        active           t   t      t        t     nil   )
     (  active       label        active           t   t      t        t      t    )
     (  poly         drawing      poly             t   t      t        t      t    )
     (  poly         pin          poly             t   t      t        t      t    )
     (  poly         net          poly            nil nil     t        t     nil   )
     (  poly         boundary     poly            nil nil     t        t     nil   )
     (  poly         dummy        poly             t   t      t        t     nil   )
     (  poly         label        poly             t   t      t        t      t    )
     (  contact      drawing      contact          t   t      t        t      t    )
     (  contact      net          contact         nil nil     t        t     nil   )
     (  contact      boundary     contact         nil nil     t        t     nil   )
     (  contact      dummy        contact          t   t      t        t     nil   )
     (  contact      label        contact          t   t      t        t      t    )
     (  metal1       drawing      metal1           t   t      t        t      t    )
     (  metal1       pin          metal1P          t   t      t        t      t    )
     (  metal1       net          metal1          nil nil     t        t     nil   )
     (  metal1       boundary     metal1          nil nil     t        t     nil   )
     (  metal1       dummy        metal1           t   t      t        t     nil   )
     (  metal1       blockage     metal1           t   t      t        t     nil   )
     (  metal1       label        metal1           t   t      t        t      t    )
     (  via1         drawing      via1             t   t      t        t      t    )
     (  via1         net          via1            nil nil     t        t     nil   )
     (  via1         boundary     via1            nil nil     t        t     nil   )
     (  via1         dummy        via1             t   t      t        t     nil   )
     (  via1         label        via1             t   t      t        t      t    )
     (  metal2       drawing      metal2           t   t      t        t      t    )
     (  metal2       pin          metal2           t   t      t        t      t    )
     (  metal2       net          metal2          nil nil     t        t     nil   )
     (  metal2       boundary     metal2          nil nil     t        t     nil   )
     (  metal2       dummy        metal2           t   t      t        t     nil   )
     (  metal2       blockage     metal2           t   t      t        t     nil   )
     (  metal2       label        metal2           t   t      t        t      t    )
     (  via2         drawing      via2             t   t      t        t      t    )
     (  via2         net          via2            nil nil     t        t     nil   )
     (  via2         boundary     via2            nil nil     t        t     nil   )
     (  via2         dummy        via2             t   t      t        t     nil   )
     (  via2         label        via2             t   t      t        t      t    )
     (  metal3       drawing      metal3           t   t      t        t      t    )
     (  metal3       pin          metal3           t   t      t        t      t    )
     (  metal3       net          metal3          nil nil     t        t     nil   )
     (  metal3       boundary     metal3          nil nil     t        t     nil   )
     (  metal3       dummy        metal3           t   t      t        t     nil   )
     (  metal3       blockage     metal3           t   t      t        t     nil   )
     (  metal3       label        metal3           t   t      t        t      t    )
     (  via3         drawing      via3             t   t      t        t      t    )
     (  via3         net          via3            nil nil     t        t     nil   )
     (  via3         boundary     via3            nil nil     t        t     nil   )
     (  via3         dummy        via3             t   t      t        t     nil   )
     (  via3         label        via3             t   t      t        t      t    )
     (  metal4       drawing      metal4           t   t      t        t      t    )
     (  metal4       pin          metal4           t   t      t        t      t    )
     (  metal4       net          metal4          nil nil     t        t     nil   )
     (  metal4       boundary     metal4          nil nil     t        t     nil   )
     (  metal4       dummy        metal4           t   t      t        t     nil   )
     (  metal4       blockage     metal4           t   t      t        t     nil   )
     (  metal4       label        metal4           t   t      t        t      t    )
     (  via4         drawing      via4             t   t      t        t      t    )
     (  via4         net          via4            nil nil     t        t     nil   )
     (  via4         boundary     via4            nil nil     t        t     nil   )
     (  via4         dummy        via4             t   t      t        t     nil   )
     (  via4         label        via4             t   t      t        t      t    )
     (  metal5       drawing      metal5           t   t      t        t      t    )
     (  metal5       pin          metal5           t   t      t        t      t    )
     (  metal5       net          metal5          nil nil     t        t     nil   )
     (  metal5       boundary     metal5          nil nil     t        t     nil   )
     (  metal5       dummy        metal5           t   t      t        t     nil   )
     (  metal5       blockage     metal5           t   t      t        t     nil   )
     (  metal5       label        metal5           t   t      t        t      t    )
     (  via5         drawing      via5             t   t      t        t      t    )
     (  via5         net          via5            nil nil     t        t     nil   )
     (  via5         boundary     via5            nil nil     t        t     nil   )
     (  via5         dummy        via5             t   t      t        t     nil   )
     (  via5         label        via5             t   t      t        t      t    )
     (  metal6       drawing      metal6           t   t      t        t      t    )
     (  metal6       pin          metal6           t   t      t        t      t    )
     (  metal6       net          metal6          nil nil     t        t     nil   )
     (  metal6       boundary     metal6          nil nil     t        t     nil   )
     (  metal6       dummy        metal6           t   t      t        t     nil   )
     (  metal6       blockage     metal6           t   t      t        t     nil   )
     (  metal6       label        metal6           t   t      t        t      t    )
     (  via6         drawing      via6             t   t      t        t      t    )
     (  via6         net          via6            nil nil     t        t     nil   )
     (  via6         boundary     via6            nil nil     t        t     nil   )
     (  via6         dummy        via6             t   t      t        t     nil   )
     (  via6         label        via6             t   t      t        t      t    )
     (  metal7       drawing      metal7           t   t      t        t      t    )
     (  metal7       pin          metal7           t   t      t        t      t    )
     (  metal7       net          metal7          nil nil     t        t     nil   )
     (  metal7       boundary     metal7          nil nil     t        t     nil   )
     (  metal7       dummy        metal7           t   t      t        t     nil   )
     (  metal7       blockage     metal7           t   t      t        t     nil   )
     (  metal7       label        metal7           t   t      t        t      t    )
     (  via7         drawing      via7             t   t      t        t      t    )
     (  via7         net          via7            nil nil     t        t     nil   )
     (  via7         boundary     via7            nil nil     t        t     nil   )
     (  via7         dummy        via7             t   t      t        t     nil   )
     (  via7         label        via7             t   t      t        t      t    )
     (  metal8       drawing      metal8           t   t      t        t      t    )
     (  metal8       pin          metal8           t   t      t        t      t    )
     (  metal8       net          metal8          nil nil     t        t     nil   )
     (  metal8       boundary     metal8          nil nil     t        t     nil   )
     (  metal8       dummy        metal8           t   t      t        t     nil   )
     (  metal8       blockage     metal8           t   t      t        t     nil   )
     (  metal8       label        metal8           t   t      t        t      t    )
     (  via8         drawing      via8             t   t      t        t      t    )
     (  via8         net          via8            nil nil     t        t     nil   )
     (  via8         boundary     via8            nil nil     t        t     nil   )
     (  via8         dummy        via8             t   t      t        t     nil   )
     (  via8         label        via8             t   t      t        t      t    )
     (  metal9       drawing      metal9           t   t      t        t      t    )
     (  metal9       pin          metal9           t   t      t        t      t    )
     (  metal9       net          metal9          nil nil     t        t     nil   )
     (  metal9       boundary     metal9          nil nil     t        t     nil   )
     (  metal9       dummy        metal9           t   t      t        t     nil   )
     (  metal9       blockage     metal9           t   t      t        t     nil   )
     (  metal9       label        metal9           t   t      t        t      t    )
     (  via9         drawing      via9             t   t      t        t      t    )
     (  via9         net          via9            nil nil     t        t     nil   )
     (  via9         boundary     via9            nil nil     t        t     nil   )
     (  via9         dummy        via9             t   t      t        t     nil   )
     (  via9         label        via9             t   t      t        t      t    )
     (  metal10      drawing      metal10          t   t      t        t      t    )
     (  metal10      pin          metal10          t   t      t        t      t    )
     (  metal10      net          metal10         nil nil     t        t     nil   )
     (  metal10      boundary     metal10         nil nil     t        t     nil   )
     (  metal10      dummy        metal10          t   t      t        t     nil   )
     (  metal10      blockage     metal10          t   t      t        t     nil   )
     (  metal10      label        metal10          t   t      t        t      t    )
    ;System-reserved layers:
    ; (  Unrouted     drawing      Unrouted         t   t      t        t     nil   )
    ; (  Unrouted     drawing1     Unrouted1        t   t      t        t     nil   )
    ; (  Unrouted     drawing2     Unrouted2        t   t      t        t     nil   )
    ; (  Unrouted     drawing3     Unrouted3        t   t      t        t     nil   )
    ; (  Unrouted     drawing4     Unrouted4        t   t      t        t     nil   )
    ; (  Unrouted     drawing5     Unrouted5        t   t      t        t     nil   )
    ; (  Unrouted     drawing6     Unrouted6        t   t      t        t     nil   )
    ; (  Unrouted     drawing7     Unrouted7        t   t      t        t     nil   )
    ; (  Unrouted     drawing8     Unrouted8        t   t      t        t     nil   )
    ; (  Unrouted     drawing9     Unrouted9        t   t      t        t     nil   )
    ; (  Row          drawing      Row              t   t      t        t     nil   )
    ; (  Row          label        RowLbl           t   t      t        t     nil   )
    ; (  Group        drawing      Group            t   t      t        t     nil   )
    ; (  Group        label        GroupLbl         t   t      t        t     nil   )
    ; (  Cannotoccupy drawing      Cannotoccupy     t   t      t        t     nil   )
    ; (  Cannotoccupy boundary     CannotoccupyBnd  t   t      t        t     nil   )
    ; (  Canplace     drawing      Canplace         t   t      t        t     nil   )
    ; (  hardFence    drawing      hardFence        t   t      t        t     nil   )
    ; (  softFence    drawing      softFence        t   t      t        t     nil   )
    ; (  y0           drawing      y0               t   t      t        t     nil   )
    ; (  y1           drawing      y1               t   t      t        t     nil   )
    ; (  y2           drawing      y2               t   t      t        t     nil   )
    ; (  y3           drawing      y3               t   t      t        t     nil   )
    ; (  y4           drawing      y4               t   t      t        t     nil   )
    ; (  y5           drawing      y5               t   t      t        t     nil   )
    ; (  y6           drawing      y6               t   t      t        t     nil   )
    ; (  y7           drawing      y7               t   t      t        t     nil   )
    ; (  y8           drawing      y8               t   t      t        t     nil   )
    ; (  y9           drawing      y9               t   t      t        t     nil   )
    ; (  designFlow   drawing      designFlow       t  nil    nil      nil    nil   )
    ; (  designFlow   drawing1     designFlow1      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing2     designFlow2      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing3     designFlow3      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing4     designFlow4      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing5     designFlow5      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing6     designFlow6      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing7     designFlow7      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing8     designFlow8      t  nil    nil      nil    nil   )
    ; (  designFlow   drawing9     designFlow9      t  nil    nil      nil    nil   )
    ; (  stretch      drawing      stretch          t   t      t        t     nil   )
    ; (  edgeLayer    drawing      edgeLayer        t   t      t        t     nil   )
    ; (  edgeLayer    pin          edgeLayerPin     t   t      t        t     nil   )
    ; (  changedLayer tool0        changedLayerTl0  t  nil     t       nil    nil   )
    ; (  changedLayer tool1        changedLayerTl1  t  nil     t       nil    nil   )
    ; (  unset        drawing      unset            t   t      t        t     nil   )
    ; (  unknown      drawing      unknown          t   t      t        t     nil   )
    ; (  spike        drawing      spike            t   t      t        t     nil   )
    ; (  hiz          drawing      hiz              t   t      t        t     nil   )
    ; (  resist       drawing      resist           t   t      t        t     nil   )
    ; (  drive        drawing      drive            t   t      t        t     nil   )
    ; (  supply       drawing      supply           t   t      t        t     nil   )
    ; (  wire         drawing      wire             t   t      t        t     nil   )
    ; (  wire         label        wireLbl          t   t      t        t     nil   )
    ; (  wire         flight       wireFlt          t   t      t        t     nil   )
    ; (  pin          label        pinLbl           t   t      t        t     nil   )
    ; (  pin          drawing      pin              t   t      t        t     nil   )
    ; (  pin          annotate     pinAnt           t   t      t        t     nil   )
     (  text         drawing      text             t   t      t        t     nil   )
     (  text         drawing1     text1            t   t      t        t     nil   )
     (  text         drawing2     text2            t   t      t        t     nil   )
    ; (  device       drawing      device           t   t      t        t     nil   )
    ; (  device       label        deviceLbl        t   t      t        t     nil   )
    ; (  device       drawing1     device1          t   t      t        t     nil   )
    ; (  device       drawing2     device2          t   t      t        t     nil   )
    ; (  device       annotate     deviceAnt        t   t      t        t     nil   )
    ; (  border       drawing      border           t   t      t        t     nil   )
    ; (  snap         drawing      snap             t   t      t        t     nil   )
    ; (  align        drawing      defaultPacket    t   t      t        t     nil   )
     (  prBoundary   drawing      prBoundary       t   t      t        t      t    )
     (  prBoundary   boundary     prBoundaryBnd    t   t      t        t     nil   )
     (  prBoundary   label        prBoundaryLbl    t   t      t        t     nil   )
    ; (  instance     drawing      instance         t   t      t        t     nil   )
    ; (  instance     label        instanceLbl      t   t      t        t     nil   )
    ; (  annotate     drawing      annotate         t   t      t        t     nil   )
    ; (  annotate     drawing1     annotate1        t   t      t        t     nil   )
    ; (  annotate     drawing2     annotate2        t   t      t        t     nil   )
    ; (  annotate     drawing3     annotate3        t   t      t        t     nil   )
    ; (  annotate     drawing4     annotate4        t   t      t        t     nil   )
    ; (  annotate     drawing5     annotate5        t   t      t        t     nil   )
    ; (  annotate     drawing6     annotate6        t   t      t        t     nil   )
    ; (  annotate     drawing7     annotate7        t   t      t        t     nil   )
    ; (  annotate     drawing8     annotate8        t   t      t        t     nil   )
    ; (  annotate     drawing9     annotate9        t   t      t        t     nil   )
    ; (  marker       warning      markerWarn       t   t      t        t     nil   )
    ; (  marker       error        markerErr        t   t      t        t     nil   )
    ; (  select       drawing      select           t   t      t        t     nil   )
    ; (  grid         drawing      grid             t  nil     t       nil    nil   )
    ; (  grid         drawing1     grid1            t  nil     t       nil    nil   )
    ; (  axis         drawing      axis             t  nil     t        t     nil   )
     (  hilite       drawing      hilite           t   t      t        t     nil   )
     (  hilite       drawing1     hilite1          t   t      t        t     nil   )
     (  hilite       drawing2     hilite2          t   t      t        t     nil   )
     (  hilite       drawing3     hilite3          t   t      t        t     nil   )
     (  hilite       drawing4     hilite4          t   t      t        t     nil   )
     (  hilite       drawing5     hilite5          t   t      t        t     nil   )
     (  hilite       drawing6     hilite6          t   t      t        t     nil   )
     (  hilite       drawing7     hilite7          t   t      t        t     nil   )
     (  hilite       drawing8     hilite8          t   t      t        t     nil   )
     (  hilite       drawing9     hilite9          t   t      t        t     nil   )
     (  background   drawing      background       t  nil     t       nil    nil   )
  ) ;techDisplays

) ;layerDefinitions



;********************************
; LAYER RULES
;********************************

layerRules(
  equivalentLayers(
    ;(  list of layers  )
    ;(  --------------  )
  ) ;equivalentLayers

  incompatibleLayers(
    ;(  list of layers  )
    ;(  --------------  )
  ) ;incompatibleLayers

  layerFunctions(
    ;(  layer     function   [maskNumber]  )
    ;(  -----     --------   ------------  )
     (  nwell     "nwell"    11            )
     (  pwell     "pwell"    12            )
     (  nimplant  "ndiff"    13            )
     (  pimplant  "pdiff"    14            )
     (  active    "other"    15            )
     (  poly      "poly"     16            )
     (  contact   "cut"      17            )
     (  metal1    "metal"    21            )
     (  via1      "cut"      22            )
     (  metal2    "metal"    23            )
     (  via2      "cut"      24            )
     (  metal3    "metal"    25            )
     (  via3      "cut"      26            )
     (  metal4    "metal"    27            )
     (  via4      "cut"      28            )
     (  metal5    "metal"    29            )
     (  via5      "cut"      30            )
     (  metal6    "metal"    31            )
     (  via6      "cut"      32            )
     (  metal7    "metal"    33            )
     (  via7      "cut"      34            )
     (  metal8    "metal"    35            )
     (  via8      "cut"      36            )
     (  metal9    "metal"    37            )
     (  via9      "cut"      38            )
     (  metal10   "metal"    39            )
  ) ;layerFunctions

  viaLayers(
    ;(  layer1    viaLayer   layer2   )
    ;(  ------    --------   ------   )
     (  poly      contact    metal1   )
     (  metal1    via1       metal2   )
     (  metal2    via2       metal3   )
     (  metal3    via3       metal4   )
     (  metal4    via4       metal5   )
     (  metal5    via5       metal6   )
     (  metal6    via6       metal7   )
     (  metal7    via7       metal8   )
     (  metal8    via8       metal9   )
     (  metal9    via9       metal10  )
  ) ;viaLayers

  mfgGridResolution(
    ;(  Layer     Value     )
    ;(  -----     -----     )
     (  0.001000  )
  ) ;mfgGridResolution

  routingDirections(
    ;(  layer     direction     )
    ;(  -----     ---------     )
     (  metal1    "horizontal"  )
     (  metal2    "vertical"    )
     (  metal3    "horizontal"  )
     (  metal4    "vertical"    )
     (  metal5    "horizontal"  )
     (  metal6    "vertical"    )
     (  metal7    "horizontal"  )
     (  metal8    "vertical"    )
     (  metal9    "horizontal"  )
     (  metal10   "vertical"    )
  ) ;routingDirections

  currentDensity(
    ;(  rule                	layer1    	layer2    	value  )
    ;(  ----                	------    	------    	-----  )
  ) ;currentDensity

  currentDensityTables(
    ;( rule                	layer1    
    ;  (( index1Definitions	[index2Definitions]) [defaultValue] )
    ;  (table))
    ;( ----------------------------------------------------------------------)
  ) ;currentDensityTables

) ;layerRules



;********************************
; VIADEFS
;********************************

viaDefs(
  standardViaDefs(
    ;(  viaDefName   layer1   layer2   (cutLayer  cutWidth  cutHeight  [resistancePerCut])
    ;   (cutRows  cutCols  (cutSpace))   (layer1Enc)   (layer2Enc)   (layer1Offset)   (layer2Offset)
    ;   (origOffset)   [implant1   (implant1Enc)   [implant2   (implant2Enc)   [wellSubstrate]]]   )
    ;(  -----------------------------------------------------------------------------------------  )
     (  poly_metal1   poly   metal1   ("contact"  0.065  0.065)   (1  1  (0.075  0.075))
        (0.003  0.003)   (0.009  0.009)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  nwell_metal1   nwell   metal1   ("contact"  0.065  0.065)   (1  1  (0.075  0.075))
        (0.003  0.003)   (0.009  0.009)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)
        nimplant   (0.009  0.009)   active   (0.009  0.009)                                           )
     (  pwell_metal1   pwell   metal1   ("contact"  0.065  0.065)   (1  1  (0.075  0.075))
        (0.003  0.003)   (0.009  0.009)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)
        pimplant   (0.009  0.009)   active   (0.009  0.009)   substrate                               )
     (  nimplant_metal1   active   metal1   ("contact"  0.065  0.065)   (1  1  (0.075  0.075))
        (0.003  0.003)   (0.009  0.009)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)
        nimplant   (0.009  0.009)                                                                     )
     (  pimplant_metal1   active   metal1   ("contact"  0.065  0.065)   (1  1  (0.075  0.075))
        (0.003  0.003)   (0.009  0.009)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)
        pimplant   (0.009  0.009)                                                                     )
     (  metal1_metal2   metal1   metal2   ("via1"  0.065  0.065)   (1  1  (0.075  0.075))
        (0.004  0.004)   (0.004  0.004)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal2_metal3   metal2   metal3   ("via2"  0.070  0.070)   (1  1  (0.085  0.085))
        (0.004  0.004)   (0.004  0.004)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal3_metal4   metal3   metal4   ("via3"  0.070  0.070)   (1  1  (0.085  0.085))
        (0.004  0.004)   (0.016  0.016)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal4_metal5   metal4   metal5   ("via4"  0.140  0.140)   (1  1  (0.160  0.160))
        (0.007  0.007)   (0.025  0.025)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal5_metal6   metal5   metal6   ("via5"  0.140  0.140)   (1  1  (0.160  0.160))
        (0.012  0.012)   (0.012  0.012)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal6_metal7   metal6   metal7   ("via6"  0.140  0.140)   (1  1  (0.160  0.160))
        (0.012  0.012)   (0.054  0.054)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal7_metal8   metal7   metal8   ("via7"  0.400  0.400)   (1  1  (0.440  0.440))
        (0.020  0.020)   (0.020  0.020)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal8_metal9   metal8   metal9   ("via8"  0.400  0.400)   (1  1  (0.440  0.440))
        (0.020  0.020)   (0.130  0.130)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
     (  metal9_metal10   metal9   metal10   ("via9"  0.800  0.800)   (1  1  (0.880  0.880))
        (0.050  0.050)   (0.050  0.050)   (0.0  0.0)   (0.0  0.0)   (0.0  0.0)                     )
  ) ;standardViaDefs

) ;viaDefs



;********************************
; CONSTRAINT GROUPS
;********************************

constraintGroups(
  ;(  constraintGroupName   [ [override]  [defName]  [operator]  ]

   (  "LEFDefaultRouteSpec"   nil
      interconnect(  ( validLayers  (metal1  metal2  metal3  metal4  metal5  metal6  metal7
                                     metal8  metal9  metal10))
      ) ;interconnect

      routingGrids(
        (  horizontalPitch   "metal1"    0.140  )
        (  verticalPitch     "metal1"    0.140  )
        (  horizontalPitch   "metal2"    0.140  )
        (  verticalPitch     "metal2"    0.140  )
        (  horizontalPitch   "metal3"    0.140  )
        (  verticalPitch     "metal3"    0.140  )
        (  horizontalPitch   "metal4"    0.280  )
        (  verticalPitch     "metal4"    0.280  )
        (  horizontalPitch   "metal5"    0.280  )
        (  verticalPitch     "metal5"    0.280  )
        (  horizontalPitch   "metal6"    0.280  )
        (  verticalPitch     "metal6"    0.280  )
        (  horizontalPitch   "metal7"    0.800  )
        (  verticalPitch     "metal7"    0.800  )
        (  horizontalPitch   "metal8"    0.800  )
        (  verticalPitch     "metal8"    0.800  )
        (  horizontalPitch   "metal9"    1.600  )
        (  verticalPitch     "metal9"    1.600  )
        (  horizontalPitch   "metal10"   1.600  )
        (  verticalPitch     "metal10"   1.600  )
      ) ;routingGrids

      interconnect(  ( validVias  (  poly_metal1  nwell_metal1  pwell_metal1  nimplant_metal1  pimplant_metal1
                                     metal1_metal2  metal2_metal3  metal3_metal4  metal4_metal5
                                     metal5_metal6  metal6_metal7  metal7_metal8  metal8_metal9
                                     metal9_metal10   ) )
      ) ;interconnect
   ) ;LEFDefaultRouteSpec


  ;(group      [override])
   ( "LEFRouting"  nil
      interconnect(  ( validLayers  (metal1  metal2  metal3  metal4  metal5  metal6
                                   metal7  metal8  metal9  metal10)  )
      ) ;interconnect
      routingGrids(
        (  horizontalPitch   "metal1"    0.140  )
        (  verticalPitch     "metal1"    0.140  )
        (  horizontalPitch   "metal2"    0.140  )
        (  verticalPitch     "metal2"    0.140  )
        (  horizontalPitch   "metal3"    0.140  )
        (  verticalPitch     "metal3"    0.140  )
        (  horizontalPitch   "metal4"    0.280  )
        (  verticalPitch     "metal4"    0.280  )
        (  horizontalPitch   "metal5"    0.280  )
        (  verticalPitch     "metal5"    0.280  )
        (  horizontalPitch   "metal6"    0.280  )
        (  verticalPitch     "metal6"    0.280  )
        (  horizontalPitch   "metal7"    0.800  )
        (  verticalPitch     "metal7"    0.800  )
        (  horizontalPitch   "metal8"    0.800  )
        (  verticalPitch     "metal8"    0.800  )
        (  horizontalPitch   "metal9"    1.600  )
        (  verticalPitch     "metal9"    1.600  )
        (  horizontalPitch   "metal10"   1.600  )
        (  verticalPitch     "metal10"   1.600  )
      ) ;routingGrids

      interconnect(  ( validVias  (  poly_metal1  nwell_metal1  pwell_metal1  nimplant_metal1  pimplant_metal1
                                     metal1_metal2  metal2_metal3  metal3_metal4  metal4_metal5
                                     metal5_metal6  metal6_metal7  metal7_metal8  metal8_metal9
                                     metal9_metal10   ) )
      ) ;interconnect
    ) ;LEFRouting

    (  "foundry"   nil
      interconnect(
        ( validLayers (  metal1  metal2  metal3  metal4  metal5  metal6  metal7  metal8
              metal9  metal10  via1  via2  via3  via4  via5
              via6  via7  via8  via9  contact  poly  active
              pwell  nwell  pimplant  nimplant )
        ) ;validLayers
      ) ;interconnect

      orderedSpacings(
        (  minViaExtension  "metal1"   "via1"  'oneThree  ( 0.004 0.004 )  )
        (  minViaExtension  "metal2"   "via1"  'oneThree  ( 0.004 0.004 )  )
        (  minViaExtension  "metal2"   "via2"  'oneThree  ( 0.004 0.004 )  )
        (  minViaExtension  "metal3"   "via2"  'oneThree  ( 0.004 0.004 )  )
        (  minViaExtension  "metal3"   "via3"  'oneThree  ( 0.004 0.004 )  )
        (  minViaExtension  "metal4"   "via3"  'oneThree  ( 0.006 0.006 )  )
        (  minViaExtension  "metal4"   "via4"  'oneThree  ( 0.006 0.006 )  )
        (  minViaExtension  "metal5"   "via4"  'oneThree  ( 0.010 0.010 )  )
        (  minViaExtension  "metal5"   "via5"  'oneThree  ( 0.010 0.010 )  )
        (  minViaExtension  "metal6"   "via5"  'oneThree  ( 0.010 0.010 )  )
        (  minViaExtension  "metal6"   "via6"  'oneThree  ( 0.010 0.010 )  )
        (  minViaExtension  "metal7"   "via6"  'oneThree  ( 0.015 0.015 )  )
        (  minViaExtension  "metal7"   "via7"  'oneThree  ( 0.015 0.015 )  )
        (  minViaExtension  "metal8"   "via7"  'oneThree  ( 0.015 0.015 )  )
        (  minViaExtension  "metal8"   "via8"  'oneThree  ( 0.015 0.015 )  )
        (  minViaExtension  "metal9"   "via8"  'oneThree  ( 0.020 0.020 )  )
        (  minViaExtension  "metal9"   "via9"  'oneThree  ( 0.020 0.020 )  )
        (  minViaExtension  "metal10"  "via9"  'oneThree  ( 0.020 0.020 )  )
      ) ;orderedSpacings    

      spacings(
        (  minWidth            "nwell"     0.004  )
        (  minWidth            "pwell"     0.004  )
        (  minWidth            "active"    0.004  )
        (  minWidth            "nimplant"  0.004  )
        (  minWidth            "pimplant"  0.004  )
        (  minWidth            "poly"      0.050  )
        (  minWidth            "contact"   0.024  )
        (  minWidth            "metal1"    0.065  )
        (  minWidth            "via1"      0.065  )
        (  minWidth            "metal2"    0.070  )
        (  minWidth            "via2"      0.070  )
        (  minWidth            "metal3"    0.070  )
        (  minWidth            "via3"      0.070  )
        (  minWidth            "metal4"    0.140  )
        (  minWidth            "via4"      0.140  )
        (  minWidth            "metal5"    0.140  )
        (  minWidth            "via5"      0.140  )
        (  minWidth            "metal6"    0.140  )
        (  minWidth            "via6"      0.140  )
        (  minWidth            "metal7"    0.400  )
        (  minWidth            "via7"      0.400  )
        (  minWidth            "metal8"    0.400  )
        (  minWidth            "via8"      0.400  )
        (  minWidth            "metal9"    0.800  )
        (  minWidth            "via9"      0.800  )
        (  minWidth            "metal10"   0.800  )
        (  minLength           "nwell"     0.004  )
        (  minLength           "pwell"     0.004  )
        (  minLength           "active"    0.004  )
        (  minLength           "nimplant"  0.004  )
        (  minLength           "pimplant"  0.004  )
        (  minLength           "poly"      0.022  )
        (  minLength           "contact"   0.024  )
        (  minLength           "metal1"    0.036  )
        (  minLength           "via1"      0.028  )
        (  minLength           "metal2"    0.036  )
        (  minLength           "via2"      0.028  )
        (  minLength           "metal3"    0.036  )
        (  minLength           "via3"      0.028  )
        (  minLength           "metal4"    0.060  )
        (  minLength           "via4"      0.048  )
        (  minLength           "metal5"    0.096  )
        (  minLength           "via5"      0.076  )
        (  minLength           "metal6"    0.096  )
        (  minLength           "via6"      0.076  )
        (  minLength           "metal7"    0.180  )
        (  minLength           "via7"      0.150  )
        (  minLength           "metal8"    0.180  )
        (  minLength           "via8"      0.150  )
        (  minLength           "metal9"    0.400  )
        (  minLength           "via9"      0.360  )
        (  minLength           "metal10"   0.400  )
        (  minSpacing          "nwell"     "active"   0.004  )
        (  minSpacing          "pwell"     "active"   0.004  )
        (  minSpacing          "active"    0.004  )
        (  minSpacing          "nimplant"  0.004  )
        (  minSpacing          "pimplant"  0.004  )
        (  minSpacing          "poly"      0.026  )
        (  minSpacing          "contact"   0.026  )
        (  minSpacing          "metal1"    0.040  )
        (  minSpacing          "via1"      0.028  )
        (  minSpacing          "metal2"    0.040  )
        (  minSpacing          "via2"      0.028  )
        (  minSpacing          "metal3"    0.040  )
        (  minSpacing          "via3"      0.028  )
        (  minSpacing          "metal4"    0.070  )
        (  minSpacing          "via4"      0.048  )
        (  minSpacing          "metal5"    0.110  )
        (  minSpacing          "via5"      0.076  )
        (  minSpacing          "metal6"    0.110  )
        (  minSpacing          "via6"      0.076  )
        (  minSpacing          "metal7"    0.210  )
        (  minSpacing          "via7"      0.150  )
        (  minSpacing          "metal8"    0.210  )
        (  minSpacing          "via8"      0.150  )
        (  minSpacing          "metal9"    0.400  )
        (  minSpacing          "via9"      0.360  )
        (  minSpacing          "metal10"   0.400  )
        (  minSameNetSpacing   "nwell"     0.004  )
        (  minSameNetSpacing   "pwell"     0.004  )
        (  minSameNetSpacing   "active"    0.004  )
        (  minSameNetSpacing   "nimplant"  0.004  )
        (  minSameNetSpacing   "pimplant"  0.004  )
        (  minSameNetSpacing   "poly"      0.026  )
        (  minSameNetSpacing   "contact"   0.026  )
        (  minSameNetSpacing   "metal1"    0.040  )
        (  minSameNetSpacing   "metal2"    0.040  )
        (  minSameNetSpacing   "metal3"    0.040  )
        (  minSameNetSpacing   "metal4"    0.070  )
        (  minSameNetSpacing   "metal5"    0.110  )
        (  minSameNetSpacing   "metal6"    0.110  )
        (  minSameNetSpacing   "metal7"    0.210  )
        (  minSameNetSpacing   "metal8"    0.210  )
        (  minSameNetSpacing   "metal9"    0.400  )
        (  minSameNetSpacing   "metal10"   0.400  )
      ) ;spacings

      spacingTables(
        (  minDensity "metal1"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal2"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal3"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal4"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal5"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal6"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal7"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal8"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal9"  (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  minDensity "metal10" (( "step" nil nil "window" nil nil ) 25.0)  ((50.0 100.0) 25.0 ) )
        (  maxDensity "metal1"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal2"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal3"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal4"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal5"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal6"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal7"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal8"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal9"  (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
        (  maxDensity "metal10" (( "step" nil nil "window" nil nil ) 75.0)  ((50.0 100.0) 75.0 ) )
      ) ;spacingTables

    ) ;foundry
) ;constraintGroups

